<?php
/* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 2.4.0-1                                              |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: index.php,v 1.1 2013-06-10 07:10:30 Nikita Rukavkov admin@voip-lab.ru Exp $ */

function _moduleContent(&$smarty, $module_name)
{

    foreach($_POST as $key=>$val){
        $val = preg_replace("/<.*?>/","",$val);
        $_POST[$key] = $val;
    }

    include_once "libs/paloSantoForm.class.php";
    include_once "libs/paloSantoGrid.class.php";
    include_once "libs/paloSantoConfig.class.php";
    include_once "libs/paloSantoNetwork.class.php";
    include_once "libs/helper.class.php";
    
    include_once "modules/$module_name/configs/default.conf.php";
    include_once "modules/$module_name/libs/paloSantoOpenVPN.class.php";
    
    global $arrConf;
    global $arrLang;
    global $arrLangModule;
    
    
    $lang=get_language();
    $lang_file="modules/$module_name/lang/$lang.lang";

    
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']); 
    
    $pDB = new paloDB($arrConfig['dsn_conn_database']);
    
    if (file_exists("$base_dir/$lang_file")) include_once "$lang_file";
    else include_once "modules/$module_name/lang/en.lang";    
    
    
    $paloOpenVPN = new PaloSantoOpenVPN($pDB);    
    
    $arrLang = array_merge($arrLang,$arrLangModule);
    
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    $templates_dir=(isset($arrConfig['templates_dir']))?$arrConfig['templates_dir']:'themes';
    $local_templates_dir="$base_dir/modules/$module_name/".$templates_dir.'/'.$arrConf['theme'];



    //SUBMIT ADD NEW USER
    if(isset($_POST['add_new_connection']))
    {
	$arrFillUser = array();
        foreach(array('common_name','autostart') as $v) 
	    if(isset($_POST[$v])) {
	        $space_filter = str_replace(' ','',$_POST[$v]);
	        $space_filter = preg_replace('/\s/', '', $space_filter);
	        $arrFillUser[$v] = $space_filter;
	        $$v = $space_filter;
	    }

	include_once("libs/paloSantoForm.class.php");
	$oForm = new paloForm($smarty, createNewConnectionForm($arrLang,$paloOpenVPN));
	$helper = new helper();

	if(!$helper->validate('alphanum',$_POST['common_name']))
	{
	    $smarty->assign("mb_title", $arrLang["Validation Error"]);
	    $smarty->assign("mb_message", $arrLang["ALPHANUM_ERROR"]);
	    $smarty->assign("CANCEL", $arrLang["Cancel"]);
	    $smarty->assign("ADD_NEW_CONNECTION", $arrLang["Save Connection"]);
	    $smarty->assign("icon",'modules/openvpn_client/images/openvpn_logo.png');
	    $contenidoModulo=$oForm->fetchForm("$local_templates_dir/newconnection.tpl", $arrLang["New Connection"],$arrFillUser);
	    return $contenidoModulo;
	}
	elseif($paloOpenVPN->connection_exists($_POST['common_name']))
	{
	    $smarty->assign("mb_title", $arrLang["Validation Error"]);
	    $smarty->assign("mb_message", $arrLang["Connection Name already exists"]);
	    $smarty->assign("CANCEL", $arrLang["Cancel"]);
	    $smarty->assign("ADD_NEW_CONNECTION", $arrLang["Save Connection"]);
	    $smarty->assign("icon",'modules/openvpn_client/images/openvpn_logo.png');
	    $contenidoModulo=$oForm->fetchForm("$local_templates_dir/newconnection.tpl", $arrLang["New Connection"],$arrFillUser);
	    return $contenidoModulo;
	}
	elseif(!$oForm->validateForm($_POST))
	{
	    
	    $smarty->assign("mb_title", _tr("Validation Error"));
	    $arrErrores = $oForm->arrErroresValidacion;
	    $strErrorMsg = "<b>"._tr("The following fields contain errors").":</b><br/>";
	    if(is_array($arrErrores) && count($arrErrores) > 0){
		foreach($arrErrores as $k=>$v)
		    $strErrorMsg .= "$k, ";
	    }
	    $smarty->assign("mb_message", $strErrorMsg);

	    $smarty->assign("CANCEL", $arrLang["Cancel"]);
	    $smarty->assign("ADD_NEW_CONNECTION", $arrLang["Save Connection"]);
	    $smarty->assign("icon",'modules/openvpn_client/images/openvpn_logo.png');
	    $contenidoModulo=$oForm->fetchForm("$local_templates_dir/newconnection.tpl", $arrLang["New Connection"],$arrFillUser);
	    return $contenidoModulo;
	}
	else
	{
	    if($_FILES["config_file"]["error"]<=0)
            {
        	if(!$helper->validate('textfile',$_FILES['config_file']['tmp_name']))
        	{
        	    $smarty->assign("mb_title", $arrLang["Validation Error"]);
		    $smarty->assign("mb_message", $arrLang["ERROR_FILE_FORMAT"]);
		    $smarty->assign("CANCEL", $arrLang["Cancel"]);
		    $smarty->assign("ADD_NEW_CONNECTION", $arrLang["Save Connection"]);
		    $smarty->assign("icon",'modules/openvpn_client/images/openvpn_logo.png');
		    $contenidoModulo=$oForm->fetchForm("$local_templates_dir/newconnection.tpl", $arrLang["New Connection"],$arrFillUser);
		    return $contenidoModulo;

        	}
		elseif ($paloOpenVPN->addConfigOpenVPN($arrFillUser['common_name'],$_FILES['config_file']['tmp_name'],($arrFillUser['autostart'] == 'on' ? 'TRUE' : 'FALSE'))) {
		    $smarty->assign("mb_title", $arrLang["OpenVPN Config File"]);
		    $smarty->assign("mb_message", $arrLang["SUCCESS_UPLOAD"]);
		}
		else
		{
		    $smarty->assign("mb_title", $arrLang["OpenVPN Config File"]);
		    $smarty->assign("mb_message", $arrLang["ERROR_UPLOADING"]);
		}
	    }
	    else
	    {
		$smarty->assign("mb_title", $arrLang["OpenVPN Config File"]);
		$smarty->assign("mb_message", $arrLang["ERROR_UPLOADING"]);
	    }
	}
    }
    //ADD NEW USER FORM
    elseif(isset($_POST['adduser']))
    {
    	include_once("libs/paloSantoForm.class.php");
	$oForm = new paloForm($smarty, createNewConnectionForm($arrLang,$paloOpenVPN));
	
	$smarty->assign("CANCEL", $arrLang["Cancel"]);
	$smarty->assign("ADD_NEW_CONNECTION", $arrLang["Save Connection"]);
	$smarty->assign("icon",'modules/openvpn_client/images/openvpn_logo.png');
	
	//$arrFillUser['cn']=$paloOpenVPN->loadExportVars("KEY_CN");

	$contenidoModulo=$oForm->fetchForm("$local_templates_dir/newconnection.tpl", $arrLang["New Connection"],$arrFillUser);
	return $contenidoModulo;
    }
    
    elseif(getParameter('submit_eliminar')=='Delete Connection')
    {
	$paloOpenVPN->removeFromOpenVPN(getParameter('config'));
    }
    
    elseif(getParameter('download')) {	
	if($paloOpenVPN->downloadLogs())
	{
	    $log_file='/tmp/openvpn_client_logs.zip';
	    if(file_exists($log_file) && is_readable($log_file))
	    {
		header('Content-type: application/zip');
	    	header('Content-Disposition: attachment; filename="openvpn_client_logs.zip"');
	    	readfile($log_file);
	    	exit;
	    }
	    else
	    {
		$smarty->assign("mb_title", $arrLang["Download Logs"]);
	    	$smarty->assign("mb_message", $arrLang["Error downloading log files"]);
	    }
	}       
    }

    elseif(isset($_GET['connect']))
    {
	switch(getParameter('connect'))
	{
	    case '1':
		exec($paloOpenVPN->connectOpenVPNClient(getParameter('name')));
		break;
	    case '0':
		exec($paloOpenVPN->disconnectOpenVPNClient(getParameter('name')));
		break;
	}
    }
    elseif(isset($_GET['reconnect']))
    {
	$paloOpenVPN->reconnectOpenVPNClient(getParameter('clientid'));
    }
    


    $oForm = new paloForm($smarty,$arrData);

    //Check Installation package OpenVPN
    if(!$paloOpenVPN->checkInstall('openvpn'))
    {
	$smarty->assign("mb_title", $arrLang["Installation Error"]);
        $smarty->assign("mb_message", $arrLang["OpenVPN Not Installed"]);
    }

    $smarty->assign("REQUIRED_FIELD", $arrLang["Required field"]);
    $smarty->assign("Download_Logs", $arrLang["Download Logs"]);
    $smarty->assign("RUN", $arrLang["Update"]);
    $smarty->assign("DELETE", $arrLang["Delete User"]);
    $smarty->assign("Status", $arrLang["Status"]);

    $smarty->assign("module_name",$module_name);

    $arrData=$paloOpenVPN->load_client_table();
    
    $total = count($arrData);
    
    $oGrid = new paloSantoGrid($smarty); 
 
    $action = getParameter("nav");
    $start  = getParameter("start");

    $url = array('menu' => $module_name); 
    if(isset($arrFilterExtraVars) && is_array($arrFilterExtraVars) and count($arrFilterExtraVars)>0) {
       $url = array_merge($url, $arrFilterExtraVars); 
    }

    $limit = 20;
    $oGrid->setLimit($limit);
    $oGrid->setTotal($total);
       
    $offset = $oGrid->calculateOffset();
    $end    = ($offset+$limit)<=$total ? $offset+$limit : $total;
    	
    $arrTableData=array_slice($arrData, $offset, $limit);

    $arrGrid = array("title"    => $arrLang["OpenVPN Clients List"],
                     "icon"     => "modules/openvpn_client/images/openvpn_logo.png",
                     "width"    => "99%",
                     "start"    => ($total==0) ? 0 : $offset+1,
                     "end"      => $end,
                     "url"      => $url,
                     "total"    => $total,
                     "columns"  => array($k++ => array("name"  => "",
                                    		    "property"  => "width=25%"),
		                         $k++ => array("name"  => "Id",
                		                    "property"  => "width=25%"),
		                         $k++ => array("name"  => $arrLang["Common Name"],
                                                    "property"  => "width=25%"),
		                         $k++ => array("name"  => $arrLang["Autostart"],
                                                    "property"  => "width=25%"),
                                    	 $k++ => array("name"  => $arrLang["Server"],
                                                    "property"  => "width=20%"),
                                         $k++ => array("name"  => $arrLang["Virtual Address"],
                                                    "property"  => "width=20%"),
                                         $k++ => array("name"  => $arrLang["Real Address"],
                                                    "property"  => "width=20%"),
                                         $k++ => array("name"  => _("Received (MB)"),
                                                    "property"  => "width=20%"),
                                         $k++ => array("name"  => _("Sent (MB)"),
                                                    "property"  => "width=20%"),
                                         $k++ => array("name"  => $arrLang["Connected Since"],
                                                    "property"  => "width=20%"),
                                         $k++ => array("name"  => _("State"),
                                                    "property"  => "width=20%"),
                                         $k++ => array("name"  => $arrLang["Action"],
                                                    "property"  => "width=20%")
    ));

    if(method_exists($oGrid,'customAction'))
        $oGrid->customAction("adduser", "New Connection","/images/plus2.png");


    if(method_exists($oGrid,'deleteList'))
        $oGrid->deleteList(_tr("delete User Configuration"),"submit_eliminar",_tr("Delete Connection")); 

    $htmlGrid = $oGrid->fetchGrid($arrGrid, $arrTableData, $arrLang);
    $smarty->assign("IPTABLE",$htmlGrid);
    $smarty->assign("icon",'modules/openvpn_client/images/openvpn_logo.png');

    $strReturn = $oForm->fetchForm("$local_templates_dir/index.tpl", $arrLang["OpenVPN Client"], $arrValues);
    
    return $strReturn;    
}

function createNewConnectionForm($arrLang,$paloOpenVPN)
{

    $arrayFields = array(
        "common_name"   => array("LABEL"		 => $arrLang["Common Name"],
                                 "REQUIRED"      	 => "yes",
                                 "INPUT_TYPE"    	 => "TEXT",
                                 "VALIDATION_TYPE"       => "text",
		                 "INPUT_EXTRA_PARAM"	 => array("SIZE" => "25"),
                                 "VALIDATION_EXTRA_PARAM" => ""),


        "autostart"   => array("LABEL"		 => $arrLang["Autostart"],
                                 "REQUIRED"      	 => "yes",
                                 "INPUT_TYPE"    	 => "CHECKBOX",
                                 "VALIDATION_TYPE"       => "",
		                 "INPUT_EXTRA_PARAM"	 => array("SIZE" => "25"),
                                 "VALIDATION_EXTRA_PARAM" => ""),

        "config_file" => array( "LABEL"                  => $arrLang["OpenVPN Config"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "FILE",
                                "INPUT_EXTRA_PARAM"      => array("SIZE" => "25"),
                                "VALIDATION_TYPE"        => "filename",
                                "VALIDATION_EXTRA_PARAM" => ""),
    );
    return $arrayFields;
}
?>
